; A Blackfin (ADSP-BF533) emulator
; /Mic, 2005
;
; - Not all opcodes are implemented
; - Some opcodes have inaccurate timings


.586p
.model flat,stdcall
option casemap:none


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

wsprintfA PROTO C :DWORD, :VARARG
wsprintf equ <wsprintfA>


; Set to 1 for a bunch of printf:s inside the dispatch loop
DEBUG					equ 0


.data

	CPU_IRQ_CALLBACK		equ 000h
	CPU_SET_IO_CALLBACK		equ 001h
	CPU_IO_HANDLER			equ 001h
	CPU_CYCLE_COUNT			equ 002h
	CPU_REG_PC			equ 003h
	CPU_REG_SP			equ 004h
	CPU_BREAKPOINT			equ 005h
	CPU_SPEED			equ 006h
	CPU_INPB_CALLBACK		equ 007h
	CPU_OUTPB_CALLBACK		equ 008h
	CPU_CYCLE_SCALING		equ 009h
	CPU_REG				equ 00Ah
	
	MMU_READ_BYTE_CALLBACK		equ 100h
	MMU_READ_WORD_CALLBACK		equ 101h
	MMU_WRITE_BYTE_CALLBACK		equ 102h
	MMU_WRITE_WORD_CALLBACK		equ 103h
	MMU_TRANSLATE_ADDRESS_CALLBACK	equ 104h
	MMU_READ_DWORD_CALLBACK		equ 106h
	MMU_WRITE_DWORD_CALLBACK	equ 107h

	GPU_CURRENT_SCANLINE		equ 200h
	GPU_SCREEN_WIDTH		equ 201h
	GPU_SCREEN_HEIGHT		equ 202h
	GPU_FRAME_COMPLETED		equ 203h
	GPU_SCREEN_PITCH		equ 204h

	ZOMBIE_WINDOW_HANDLE		equ 500h

	PLUGIN_NAME			equ 600h
	
	INPUT		equ 0
	OUTPUT		equ 1

	ASK		equ 0
	TELL		equ 1


	_1ARGS_PROTO	typedef PROTO :DWORD
	_2ARGS_PROTO	typedef PROTO :DWORD,:DWORD
	_4ARGS_PROTO	typedef PROTO :DWORD,:DWORD,:DWORD,:DWORD
	_1ARGS		typedef ptr _1ARGS_PROTO
	_2ARGS		typedef ptr _2ARGS_PROTO
	_4ARGS		typedef ptr _4ARGS_PROTO

	cpu_inpb	PROTO :DWORD
	cpu_outpb	PROTO :DWORD,:DWORD

	
	Overflow	db 0
	Carry		db 0
	Zero		db 0
	Negative	db 0

	flags		db 0,0,0,0,0,0,0,1
	cycle		dd 0
	breakpoint	dd 0
	speed		dd 0AC00000h	; ~180 MHz
	cpuName		db "ADSP-BF533",0

	szBranch db "Branch instruction",13,10,0
	szTrue db "true",13,10,0
	szBuffer db 80 dup (0)
	szFormat db "Read %08x at pc=%08x",13,10,0
	szFormat2 db "Instruction type %d at %08x",13,10,0
	szFormat3 db "Writing %04x at %08x",13,10,0
	szFormat4 db "Branching with link from %08x to %08x",13,10,0
	szFormat5 db "mov pc,lr (%08x)",13,10,0
	szFormat9 db "MUL r%d,%08x,%08x",13,10,0
	szFormat10 db "%08x",13,10,0
	szFormat11 db "%08x, %08x, %08x, %08x, %08x, PC=%08x",13,10,0
	szFormat12 db "Offset = %08x",13,10,0
	szFormat13 db "PC=%08x: R0..R3 = %08x, %08x, %08x, %08x | P0..P3 = %08x, %08x, %08x, %08x | LC0 = %08x, LT0 = %08x, LB0 = %08x",13,10,0
	szFormat14 db "BT: Took branch after %d iterations (CMP %08x,%08x @ %08x)",13,10,0
	szFormat15 db "BF: Took branch after %d iterations (CMP %08x,%08x @ %08x)",13,10,0
	szFormat23 db "PC=%08x: R0..R3 = %08x, %08x, %08x, %08x | P0..P5 = %08x, %08x, %08x, %08x, %08x, %08x | LC0 = %08x, LT0 = %08x, LB0 = %08x | CC = %d",13,10,0
	
.data?
	_a0	dq ?	; 40-bit accumulator 0
	_a1	dq ?	; 40-bit accumulator 1
	
	_r0	dd ?	; 
	_r1	dd ?	; 
	_r2	dd ?	;
	_r3	dd ?	; 
	_r4	dd ?	; 
	_r5	dd ?	; 
	_r6	dd ?	; 
	_r7	dd ?	; 

	_p0	dd ?
	_p1	dd ?
	_p2	dd ?
	_p3	dd ?
	_p4	dd ?
	_p5	dd ?
	_sp	dd ?
	_fp	dd ?
	
	_lt0	dd ?
	_lt1	dd ?
	_lc0	dd ?
	_lc1	dd ?
	_lb0	dd ?
	_lb1	dd ?
	
	_i0	dd ?
	_i1	dd ?
	_i2	dd ?
	_i3	dd ?

	_m0	dd ?
	_m1	dd ?
	_m2	dd ?
	_m3	dd ?

	_l0	dd ?
	_l1	dd ?
	_l2	dd ?
	_l3	dd ?

	_b0	dd ?
	_b1	dd ?
	_b2	dd ?
	_b3	dd ?
	
	_rets	dd ?
	_reti	dd ?
	_retx	dd ?
	_retn	dd ?
	_rete	dd ?
	
	_cycles dd ?
	_cycles2 dd ?
	
	_usp	dd ?
	
	_astat	dd ?
	_ac0	dd ?
	_ac0_copy dd ?
	_ac1	dd ?
	_an	dd ?
	_aq	dd ?
	_av0	dd ?
	_avs0	dd ?
	_av1	dd ?
	_avs1	dd ?
	_az	dd ?
	_cc	dd ?	
	_v	dd ?
	_v_copy dd ?
	_vs	dd ?
	

	PC	dd ?	; program counter

	
	hInst	dd ?
	hout	dd ?
	dummy 	dd ?
	lastPC 	dd ?
	lastCyc	dd ?
	loop0	dd ?
	loop1	dd ?
	physaddr dd ?
	physaddr_base dd ?
	physaddr_valid dd ?
	nextInstr dd ?
	nextAddr dd ?
	zombie	_4ARGS ?
	mmu_read_byte _1ARGS ?
	mmu_read_word _1ARGS ?
	mmu_read_dword _1ARGS ?
	mmu_write_byte _2ARGS ?
	mmu_write_word _2ARGS ?
	mmu_write_dword _2ARGS ?
	mmu_get _1ARGS ?
	mmu_translate_address _1ARGS ?
	
.code


ADD_CYCLES MACRO num
	add cycle,num ;*200h
ENDM


INSSIZE2 MACRO
	mov ebp,2
ENDM

INSSIZE4 MACRO
	mov ebp,4
ENDM


UPDATE_C MACRO
	setc byte ptr [cond]
ENDM


RETURN MACRO
	;ret
	jmp @@next_instr
ENDM


RETURN_NB MACRO
	jmp @@next_instr_nobranch
ENDM


RETURN2 MACRO
	;ret
	jmp @@next_instr_fast
ENDM

RETURN4 MACRO
	;ret
	jmp @@next_instr
ENDM


DIV0 MACRO
	mov edi,PC
	xor ecx,ecx
	div ecx
ENDM


;#####################################################################################################		

LibMain PROC hInstDLL:DWORD, reason:DWORD, unused:DWORD

        .if reason == 1		;DLL_PROCESS_ATTACH
        	mov eax,hInstDLL
        	mov hInst,eax
		mov eax,TRUE
		ret

        .elseif reason == 0	;DLL_PROCESS_DETACH
        .elseif reason == 2	;DLL_THREAD_ATTACH
        .elseif reason == 3	;DLL_THREAD_DETACH
        .endif

        mov eax,FALSE
        ret
LibMain ENDP


inpb_null PROC
	ret
inpb_null ENDP
.data
inpb_handlers dd 256 DUP(OFFSET inpb_null)
.code

outpb_null PROC dat:DWORD
	ret
outpb_null ENDP
.data
outpb_handlers dd 256 DUP(OFFSET outpb_null)
.code	


;#####################################################################################################		


align 8

op_00:
	and eax,0FFh
	.if eax == 10h
		mov eax,_rets
		mov physaddr,-1
		mov PC,eax
		ADD_CYCLES 1
		RETURN
	.endif
	DIV0
op_01:
op_02:
op_03:
op_04:
op_05:
op_06:
	DIV0
	
op_07:
	mov edx,eax
	mov ebx,eax
	and ebx,7	; m
	and eax,38h	; n
	mov ecx,[_r0 + ebx*4]
	and edx,0C0h
	shr eax,1
	add PC,2
	add physaddr,2
	; IF CC Rn = Rm
	.if edx == 000h
		.if _cc == 1
			mov [_r0 + eax],ecx
		.endif
	.elseif edx == 040h
		DIV0
	.elseif edx == 080h
		DIV0
	.elseif edx == 0C0h
		DIV0
	.endif	
	ADD_CYCLES 1
	RETURN_NB
	
op_08:
	mov edx,eax
	mov ebx,eax
	and ebx,7	; m
	and eax,38h	; n
	and edx,0C0h
	shr eax,1
	add PC,2
	add physaddr,2
	; CC = Rn == Rm
	.if edx == 000h
		mov ecx,[_r0 + ebx*4]
		cmp ecx,[_r0 + eax]
		sete byte ptr [_cc]

	; CC = Pn == Pm
	.elseif edx == 040h
		mov ecx,[_p0 + ebx*4]
		cmp ecx,[_p0 + eax]
		sete byte ptr [_cc]

	; CC = Rn < Rm
	.elseif edx == 080h
		mov ecx,[_r0 + ebx*4]
		cmp ecx,[_r0 + eax]
		setl byte ptr [_cc]

	.elseif edx == 0C0h
		DIV0
	.endif	
	ADD_CYCLES 1
	RETURN_NB
	
op_09:
op_0A:
op_0B:
	DIV0

op_0C:
	mov edx,eax
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; imm3
	mov ecx,[_r0 + ebx*4]
	and edx,0C0h
	shl eax,26

	add PC,2
	sar eax,29
	add physaddr,2
	; CC = Rn == imm3
	.if edx == 000h
		cmp ecx,eax
		sete byte ptr [_cc]
	.elseif edx == 040h

	; CC = Rn < imm3
	.elseif edx == 080h
		cmp ecx,eax
		setl byte ptr [_cc]

	.elseif edx == 0C0h
	.endif	
	ADD_CYCLES 1
	RETURN_NB
	

op_0D:
op_0E:
op_0F:
	DIV0
	
; IF !CC JUMP pcrel11m2
op_10:
op_11:
op_12:
op_13:
op_14:
op_15:
op_16:
op_17:
	.if _cc == 0
	shl eax,22	; sign-extend displacement
	sar eax,21	; ...
	ADD_CYCLES 1	; correct timing?
	add PC,eax
	mov physaddr,-1	; invalidate physical address mapping
	RETURN
	.endif
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB

; IF CC JUMP pcrel11m2	
op_18:
op_19:
op_1A:
op_1B:
op_1C:
op_1D:
op_1E:
op_1F:
	.if _cc == 1
	shl eax,22	; sign-extend displacement
	sar eax,21	; ...
	ADD_CYCLES 1	; correct timing?
	add PC,eax
	mov physaddr,-1	; invalidate physical address mapping
	RETURN
	.endif
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB
	
; JUMP.S pcrel13m2
align 8
op_20:
op_21:
op_22:
op_23:
op_24:
op_25:
op_26:
op_27:
op_28:
op_29:
op_2A:
op_2B:
op_2C:
op_2D:
op_2E:
op_2F:
	shl eax,20	; sign-extend displacement
	jz zero_jump

	sar eax,19	; ...
	ADD_CYCLES 1	; correct timing?
	add PC,eax
	mov physaddr,-1	; invalidate physical address mapping
	RETURN
	zero_jump:
	ADD_CYCLES 1
	RETURN
	
; Rn = Rm
align 8
op_30:
	mov ebx,eax
	and ebx,7	; m
	and eax,38h	; n
	mov ecx,[_r0 + ebx*4]
	shr eax,1
	add PC,2
	add physaddr,2
	mov [_r0 + eax],ecx
	ADD_CYCLES 1
	RETURN_NB
op_31:
	DIV0

op_32:
	mov ebx,eax
	mov edx,eax
	and ebx,7	; m
	and edx,0C0h
	and eax,38h	; n
	.if edx == 000h
		; Pn = Rm
		mov ecx,[_r0 + ebx*4]
		shr eax,1
		add PC,2
		add physaddr,2
		mov [_p0 + eax],ecx
		ADD_CYCLES 1
		RETURN_NB
	.elseif edx == 040h
		; Pn = Pm
		mov ecx,[_p0 + ebx*4]
		shr eax,1
		add PC,2
		add physaddr,2
		mov [_p0 + eax],ecx
		ADD_CYCLES 1
		RETURN_NB
	.endif
	DIV0
op_33:
op_34:
op_35:
op_36:
op_37:
op_38:
op_39:
op_3A:
op_3B:
	DIV0
	
; LCn = Rm
op_3C:
	mov ebx,eax
	and ebx,7	; m
	and eax,0F8h	; n
	.if eax == 0
		mov eax,[_r0 + ebx*4]
		mov _lc0,eax
		add PC,2
		add physaddr,2
		ADD_CYCLES 1
		RETURN_NB
	.elseif eax == 18h
		mov eax,[_r0 + ebx*4]
		mov _lc1,eax
		add PC,2
		add physaddr,2
		ADD_CYCLES 1
		RETURN_NB
	.endif
	DIV0
	
op_3D:
op_3E:
op_3F:
op_40:
	mov edx,eax
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; m
	shr eax,1
	mov ecx,[_r0 + eax]
	and edx,0C0h
	add physaddr,2
	.if edx == 000h
		DIV0
	.elseif edx == 040h
		DIV0
	.elseif edx == 080h
		DIV0
	.elseif edx == 0C0h
		; Rn *= Rm
		mov eax,[_r0 + ebx*4]
		imul ecx
		mov [_r0 + ebx*4],eax
	.endif	
	add PC,2
	ADD_CYCLES 1
	RETURN_NB
	
op_41:
op_42:
op_43:
	DIV0
	
; Pn -= Pm
op_44:
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; m
	add PC,2
	shr eax,1
	mov ecx,[_p0 + eax]
	add physaddr,2

	sub [_r0 + ebx*4],ecx
	ADD_CYCLES 2
	RETURN_NB

op_45:
op_46:
op_47:
op_48:
	DIV0
; CC = BITTST(Rn,imm)
op_49:
	mov ecx,eax
	add PC,2
	and ecx,0F8h		; imm
	and eax,7		; n
	shr ecx,3
	ADD_CYCLES 1
	bt [_r0 + eax*4],ecx
	setc byte ptr [_cc]
	add physaddr,2
	RETURN_NB
	
op_4A:
op_4B:
op_4C:
op_4D:
	DIV0

; Rn >>= uimm5	
op_4E:
	mov ecx,eax
	add PC,2
	shr cl,3
	and eax,7
	add physaddr,2
	shr dword ptr [_r0 + eax*4],cl
	setz byte ptr [_az]
	sets byte ptr [_an]
	seto byte ptr [_v]
	ADD_CYCLES 1
	RETURN_NB
	
; Rn <<= uimm5
op_4F:
	mov ecx,eax
	add PC,2
	shr cl,3
	and eax,7
	add physaddr,2
	shl dword ptr [_r0 + eax*4],cl
	setz byte ptr [_az]
	sets byte ptr [_an]
	seto byte ptr [_v]
	ADD_CYCLES 1
	RETURN_NB

; Rn = Rm + Rs	
op_50:
op_51:
	mov ecx,eax
	mov ebx,eax
	and ecx,1C0h	; n
	and eax,38h	; s
	and ebx,7	; m
	shr eax,1
	shr ecx,4
	mov edx,[_r0 + ebx*4]
	add edx,[_r0 + eax]
	setz byte ptr [_az]
	sets byte ptr [_an]
	seto al
	setc byte ptr [_ac0]
	mov byte ptr [_v],al
	or byte ptr [_vs],al	
	mov [_r0 + ecx],edx
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB
op_52:
op_53:
	DIV0
; Rn = Rm & Rs
op_54:
op_55:
	mov ecx,eax
	mov ebx,eax
	and ecx,1C0h	; n
	and eax,38h	; s
	and ebx,7	; m
	shr eax,1
	shr ecx,4
	mov edx,[_r0 + ebx*4]
	and edx,[_r0 + eax]
	setz byte ptr [_az]
	sets byte ptr [_an]
	mov byte ptr [_ac0],0
	mov byte ptr [_v],0
	mov [_r0 + ecx],edx
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB

; Rn = Rm | Rs
op_56:
op_57:
	mov ecx,eax
	mov ebx,eax
	and ecx,1C0h	; n
	and eax,38h	; s
	and ebx,7	; m
	shr eax,1
	shr ecx,4
	mov edx,[_r0 + ebx*4]
	or edx,[_r0 + eax]
	setz byte ptr [_az]
	sets byte ptr [_an]
	mov byte ptr [_ac0],0
	mov byte ptr [_v],0
	mov [_r0 + ecx],edx
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB

op_58:
op_59:
	DIV0
; Pn = Pm + Ps
op_5A:
op_5B:
	mov ecx,eax
	mov ebx,eax
	and ecx,1C0h	; n
	and eax,38h	; s
	and ebx,7	; m
	shr eax,1
	shr ecx,4
	mov edx,[_p0 + ebx*4]
	add edx,[_p0 + eax]
	mov [_p0 + ecx],edx
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB
	
; Pn = Pm + (Ps << 1)
op_5C:
op_5D:
	mov ecx,eax
	mov ebx,eax
	and ecx,1C0h	; n
	and eax,38h	; s
	and ebx,7	; m
	shr eax,1
	shr ecx,4
	mov edx,[_p0 + eax]
	add edx,edx
	add edx,[_p0 + ebx*4]
	mov [_p0 + ecx],edx
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB
	
op_5E:
op_5F:
	DIV0

; Rn = imm7
op_60:
op_61:
op_62:
op_63:
	mov ecx,eax
	add PC,2
	and ecx,3F8h		; imm7
	and eax,7		; n
	shl ecx,22		; sign-extend
	ADD_CYCLES 1
	sar ecx,25		; ...
	add physaddr,2
	mov [_r0 + eax*4],ecx
	RETURN_NB

; Pn = imm7	
op_68:
op_69:
op_6A:
op_6B:
	mov ecx,eax
	add PC,2
	and ecx,3F8h		; imm7
	and eax,7		; n
	shl ecx,22		; sign-extend
	ADD_CYCLES 1
	sar ecx,25		; ...
	add physaddr,2
	mov [_p0 + eax*4],ecx
	RETURN_NB

; Rn += imm7
op_64:
op_65:
op_66:
op_67:
	mov ecx,eax
	add PC,2
	and ecx,3F8h		; imm7
	and eax,7		; n
	shl ecx,22		; sign-extend
	sar ecx,25		; ...
	add physaddr,2
	add [_r0 + eax*4],ecx
	setz byte ptr [_az]
	sets byte ptr [_an]
	seto al

	setc byte ptr [_ac0]
	mov byte ptr [_v],al
	or byte ptr [_vs],al
	ADD_CYCLES 1
	RETURN_NB
	

; Pn += imm7
op_6C:
op_6D:
op_6E:
op_6F:
	mov ecx,eax
	add PC,2
	and ecx,3F8h		; imm7
	and eax,7		; n
	shl ecx,22		; sign-extend
	ADD_CYCLES 1
	sar ecx,25		; ...
	add physaddr,2
	add [_p0 + eax*4],ecx
	RETURN_NB
	
	
op_70:
op_71:
op_72:
op_73:
op_74:
op_75:
op_76:
op_77:
op_78:
op_79:
op_7A:
op_7B:
op_7C:
op_7D:
op_7E:
op_7F:

op_80:
op_81:
op_82:
op_83:
op_84:
op_85:
op_86:
op_87:
op_88:
op_89:
op_8A:
op_8B:
op_8C:
op_8D:
op_8E:
op_8F:
	DIV0

; Rn = [Pm++]	
op_90:
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; m
	shr eax,1
	mov ecx,[_p0 + eax]
	add PC,2
	add dword ptr [_p0 + eax],4
	push ebx
	invoke mmu_read_dword,ecx
	pop ebx
	add physaddr,2
	mov [_r0 + ebx*4],eax
	ADD_CYCLES 2
	RETURN_NB

; Rn = [Pm]
op_91:
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; m
	shr eax,1
	mov ecx,[_p0 + eax]
	add PC,2
	push ebx
	invoke mmu_read_dword,ecx
	pop ebx
	add physaddr,2
	mov [_r0 + ebx*4],eax
	ADD_CYCLES 2
	RETURN_NB


; [Pm++] = Rn
op_92:
	mov ebx,eax
	and eax,38h	; m
	and ebx,7	; n
	shr eax,1
	mov ecx,[_p0 + eax]
	add dword ptr [_p0 + eax],4
	add PC,2
	invoke mmu_write_dword,ecx,dword ptr [_r0 + ebx*4]
	add physaddr,2
	ADD_CYCLES 2
	RETURN_NB

; [Pm] = Rn
op_93:
	mov ebx,eax
	and eax,38h	; m
	and ebx,7	; n
	shr eax,1
	mov ecx,[_p0 + eax]
	;add dword ptr [_p0 + eax],4
	add PC,2
	invoke mmu_write_dword,ecx,dword ptr [_r0 + ebx*4]
	add physaddr,2
	ADD_CYCLES 2
	RETURN_NB
op_94:
	DIV0
; Rn = W[Pm](Z)	
op_95:
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; m
	shr eax,1
	mov ecx,[_p0 + eax]
	add PC,2
	push ebx
	invoke mmu_read_word,ecx
	pop ebx
	and eax,0FFFFh
	add physaddr,2
	mov [_r0 + ebx*4],eax
	ADD_CYCLES 2
	RETURN_NB
	
; W[Pm++] = Rn
op_96:
	mov ebx,eax
	and eax,38h	; m
	and ebx,7	; n
	shr eax,1
	mov ecx,[_p0 + eax]
	add PC,2
	add dword ptr [_p0 + eax],2
	invoke mmu_write_word,ecx,dword ptr [_r0 + ebx*4]
	add physaddr,2
	ADD_CYCLES 2
	RETURN_NB
	
; W[Pm] = Rn	
op_97:
	mov ebx,eax
	and eax,38h	; m
	and ebx,7	; n
	shr eax,1
	add PC,2
	mov ecx,[_p0 + eax]
	invoke mmu_write_word,ecx,dword ptr [_r0 + ebx*4]
	add physaddr,2
	ADD_CYCLES 2
	RETURN_NB
	
op_98:
	DIV0

; Rn = B[Pm](Z)
op_99:
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; m
	shr eax,1
	mov ecx,[_p0 + eax]
	add PC,2
	push ebx
	invoke mmu_read_byte,ecx
	pop ebx
	and eax,0FFh
	add physaddr,2
	mov [_r0 + ebx*4],eax
	ADD_CYCLES 2
	RETURN_NB

; B[Pm++] = Rn	
op_9A:
	mov ebx,eax
	and eax,38h	; m
	and ebx,7	; n
	shr eax,1
	mov ecx,[_p0 + eax]
	add PC,2
	add dword ptr [_p0 + eax],1
	invoke mmu_write_byte,ecx,dword ptr [_r0 + ebx*4]
	add physaddr,2
	ADD_CYCLES 2
	RETURN_NB
	

; B[Pm] = Rn
op_9B:
	mov ebx,eax
	and ebx,7	; n
	and eax,38h	; m
	shr eax,1
	add PC,2
	mov ecx,[_p0 + eax]
	invoke mmu_write_byte,ecx,dword ptr [_r0 + ebx*4]
	add physaddr,2
	ADD_CYCLES 2
	RETURN_NB
	
op_9C:
op_9D:
op_9E:
op_9F:
	DIV0

; Rn = [Pm + uimm6m4]
op_A0:
	mov ecx,eax
	mov ebx,eax
	and ecx,1C0h	; uimm
	and eax,38h	; s
	and ebx,7	; m
	shr eax,1
	shr ecx,4
	push eax
	add ecx,[_p0 + ebx*4]
	invoke mmu_read_dword,ecx
	pop ebx
	add PC,2
	mov [_r0 + ebx],eax
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB
op_A1:
op_A2:
op_A3:
op_A4:
op_A5:
op_A6:
op_A7:
op_A8:
op_A9:
op_AA:
op_AB:
op_AC:
op_AD:
op_AE:
op_AF:
	DIV0

; [Pm + uimm6m4] = Rn	
op_B0:
	mov ecx,eax
	mov ebx,eax
	and ecx,1C0h	; uimm
	and eax,38h	; s
	and ebx,7	; m
	shr eax,1
	shr ecx,4
	add ecx,[_p0 + ebx*4]

	invoke mmu_write_dword,ecx,dword ptr [_r0 + eax]
	add PC,2
	add physaddr,2
	ADD_CYCLES 1
	RETURN_NB
	
op_B1:
op_B2:
op_B3:
op_B4:
op_B5:
op_B6:
op_B7:
op_B8:
op_B9:
op_BA:
op_BB:
op_BC:
op_BD:
op_BE:
op_BF:
op_C0:
op_C1:
op_C2:
op_C3:
op_C4:
op_C5:
op_C6:
op_C7:
op_C8:
op_C9:
op_CA:
op_CB:
op_CC:
op_CD:
op_CE:
op_CF:
op_D0:
op_D1:
op_D2:
op_D3:
op_D4:
op_D5:
op_D6:
op_D7:
op_D8:
op_D9:
op_DA:
op_DB:
op_DC:
op_DD:
op_DE:
op_DF:
	DIV0
	
op_E0:
	mov ebx,eax
	and ebx,0F0h
	shr ebx,2
	jmp dword ptr [op_E0_subtable + ebx]

	op_E0_00:
	op_E0_10:
	op_E0_20:
	op_E0_30:
	op_E0_40:
	op_E0_50:
	op_E0_60:
	op_E0_70:
		DIV0
	; LOOP disp LC0
	op_E0_80:
		mov ebx,physaddr
		and eax,0Fh
		movzx ecx,word ptr [ebx+2]
		add eax,eax
		add ecx,ecx
		add eax,PC
		add ecx,PC
		mov _lt0,eax
		mov _lb0,ecx
		add PC,4
		add physaddr,4
		ADD_CYCLES 1
		RETURN_NB

	; LOOP disp LC1
	op_E0_90:
		mov ebx,physaddr
		and eax,0Fh
		movzx ecx,word ptr [ebx+2]
		add eax,eax
		add ecx,ecx
		add eax,PC
		add ecx,PC
		mov _lt1,eax
		mov _lb1,ecx
		add PC,4
		add physaddr,4
		ADD_CYCLES 1
		RETURN_NB

	op_E0_A0:
	op_E0_B0:
	op_E0_C0:
	op_E0_D0:
	op_E0_E0:
	op_E0_F0:
		DIV0


op_E1:
	mov ebx,eax
	and ebx,0F8h
	shr ebx,1
	jmp dword ptr [op_E1_subtable + ebx]

	; Rn.L = imm16
	op_E1_00:
		mov ebx,physaddr
		and eax,7
		mov cx,[ebx+2]
		add PC,4
		add physaddr,4
		mov word ptr [_r0 + eax*4],cx
		ADD_CYCLES 1
		RETURN_NB
	; Pn.L = imm16
	op_E1_08:
		mov ebx,physaddr
		and eax,7
		mov cx,[ebx+2]
		add PC,4
		add physaddr,4
		mov word ptr [_p0 + eax*4],cx
		ADD_CYCLES 1
		RETURN_NB
	op_E1_10:
	op_E1_18:
		DIV0
	; Rn = imm16(X)
	op_E1_20:
		mov ebx,physaddr
		and eax,7
		movsx ecx,word ptr [ebx+2]
		add PC,4
		add physaddr,4
		mov [_r0 + eax*4],ecx
		ADD_CYCLES 1
		RETURN_NB
	; Pn = imm16(X)
	op_E1_28:
		mov ebx,physaddr
		and eax,7
		movsx ecx,word ptr [ebx+2]
		add PC,4
		mov [_p0 + eax*4],ecx
		add physaddr,4
		ADD_CYCLES 1
		RETURN_NB
	op_E1_30:
	op_E1_38:
		DIV0
	; Rn.H = imm16
	op_E1_40:
		mov ebx,physaddr
		and eax,7
		mov cx,[ebx+2]
		add PC,4
		mov word ptr [_r0 + 2 + eax*4],cx
		add physaddr,4
		ADD_CYCLES 1
		RETURN_NB
	; Pn.H = imm16	
	op_E1_48:
		mov ebx,physaddr
		and eax,7
		mov cx,[ebx+2]
		add PC,4
		add physaddr,4
		mov word ptr [_p0 + 2 + eax*4],cx
		ADD_CYCLES 1
		RETURN_NB
	op_E1_50:
	op_E1_58:
		DIV0	
	op_E1_60:
	op_E1_68:
		DIV0	
	op_E1_70:
	op_E1_78:
		DIV0
	; Rn = imm16(Z)	
	op_E1_80:
		mov ebx,physaddr
		and eax,7
		movzx ecx,word ptr [ebx+2]
		add PC,4
		mov [_r0 + eax*4],ecx
		add physaddr,4
		ADD_CYCLES 1
		RETURN_NB
	; Pn = imm16(X)
	op_E1_88:
		mov ebx,physaddr
		and eax,7
		movzx ecx,word ptr [ebx+2]
		add PC,4
		mov [_p0 + eax*4],ecx
		add physaddr,4
		ADD_CYCLES 1
		RETURN_NB
	op_E1_90:
	op_E1_98:
		DIV0	
	op_E1_A0:
	op_E1_A8:
		DIV0	
	op_E1_B0:
	op_E1_B8:
		DIV0	
	op_E1_C0:
	op_E1_C8:
		DIV0	
	op_E1_D0:
	op_E1_D8:
		DIV0	
	op_E1_E0:
	op_E1_E8:
		DIV0	
	op_E1_F0:
	op_E1_F8:
		DIV0	
	


op_E2:
	DIV0
	
; Call disp
op_E3:
	mov ebx,physaddr
	shl eax,24
	movzx ecx,word ptr [ebx+2]
	mov physaddr,-1
	shl ecx,8
	mov edx,PC
	or eax,ecx
	sar eax,7
	add edx,4
	ADD_CYCLES 1
	mov _rets,edx
	add PC,eax
	RETURN
	
	
op_E4:
	mov ebx,eax
	and ebx,0C0h
	shr ebx,4
	jmp dword ptr [op_E4_subtable + ebx]
	
	op_E4_00:
	op_E4_40:
		DIV0
	; Rn = B[Pm + disp]
	op_E4_80:
		mov ebx,eax
		mov edx,physaddr
		and ebx,7	; n
		movzx ecx,word ptr [edx+2]
		and eax,38h	; m
		;add ecx,ecx
		shr eax,1
		add PC,4
		add ecx,[_p0 + eax]
		push ebx
		invoke mmu_read_byte,ecx
		pop ebx
		and eax,0FFh
		add physaddr,4
		mov [_r0 + ebx*4],eax
		ADD_CYCLES 2
		RETURN_NB

	op_E4_C0:
		DIV0

op_E5:
	DIV0
	
op_E6:
	mov ebx,eax
	and ebx,0C0h
	shr ebx,4
	jmp dword ptr [op_E6_subtable + ebx]
	

	op_E6_00:
		DIV0
	; W[Pm + disp] = Rn
	op_E6_40:
		mov ebx,eax
		mov edx,physaddr
		and ebx,7	; n
		movzx ecx,word ptr [edx+2]

		and eax,38h	; m
		add ecx,ecx

		shr eax,1
		add PC,4
		add ecx,[_p0 + eax]
		invoke mmu_write_word,ecx,dword ptr [_r0 + ebx*4]
		add physaddr,4
		ADD_CYCLES 2
		RETURN_NB

	; B[Pm + disp] = Rn
	op_E6_80:
		mov ebx,eax
		mov edx,physaddr
		and ebx,7	; n
		movzx ecx,word ptr [edx+2]
		and eax,38h	; m
		;add ecx,ecx
		shr eax,1
		add PC,4
		add ecx,[_p0 + eax]
		invoke mmu_write_byte,ecx,dword ptr [_r0 + ebx*4]
		add physaddr,4
		ADD_CYCLES 2
		RETURN_NB

	op_E6_C0:
		DIV0
	
op_E7:
op_E8:
op_E9:
op_EA:
op_EB:
op_EC:
op_ED:
op_EE:
op_EF:
op_F0:
op_F1:
op_F2:
op_F3:
op_F4:
op_F5:
op_F6:
op_F7:
op_F8:
op_F9:
op_FA:
op_FB:
op_FC:
op_FD:
op_FE:
op_FF:
	DIV0

	
.data
align 16
op_table LABEL DWORD
dd OFFSET op_00
dd OFFSET op_01
dd OFFSET op_02
dd OFFSET op_03
dd OFFSET op_04
dd OFFSET op_05
dd OFFSET op_06
dd OFFSET op_07
dd OFFSET op_08
dd OFFSET op_09
dd OFFSET op_0A
dd OFFSET op_0B
dd OFFSET op_0C
dd OFFSET op_0D
dd OFFSET op_0E
dd OFFSET op_0F
dd OFFSET op_10
dd OFFSET op_11
dd OFFSET op_12
dd OFFSET op_13
dd OFFSET op_14
dd OFFSET op_15
dd OFFSET op_16
dd OFFSET op_17
dd OFFSET op_18
dd OFFSET op_19
dd OFFSET op_1A
dd OFFSET op_1B
dd OFFSET op_1C
dd OFFSET op_1D
dd OFFSET op_1E
dd OFFSET op_1F
dd OFFSET op_20
dd OFFSET op_21
dd OFFSET op_22
dd OFFSET op_23
dd OFFSET op_24
dd OFFSET op_25
dd OFFSET op_26
dd OFFSET op_27
dd OFFSET op_28
dd OFFSET op_29
dd OFFSET op_2A
dd OFFSET op_2B
dd OFFSET op_2C
dd OFFSET op_2D
dd OFFSET op_2E
dd OFFSET op_2F
dd OFFSET op_30
dd OFFSET op_31
dd OFFSET op_32
dd OFFSET op_33
dd OFFSET op_34
dd OFFSET op_35
dd OFFSET op_36
dd OFFSET op_37
dd OFFSET op_38
dd OFFSET op_39
dd OFFSET op_3A
dd OFFSET op_3B
dd OFFSET op_3C
dd OFFSET op_3D
dd OFFSET op_3E
dd OFFSET op_3F
dd OFFSET op_40
dd OFFSET op_41
dd OFFSET op_42
dd OFFSET op_43
dd OFFSET op_44
dd OFFSET op_45
dd OFFSET op_46
dd OFFSET op_47
dd OFFSET op_48
dd OFFSET op_49
dd OFFSET op_4A
dd OFFSET op_4B
dd OFFSET op_4C
dd OFFSET op_4D
dd OFFSET op_4E
dd OFFSET op_4F
dd OFFSET op_50
dd OFFSET op_51
dd OFFSET op_52
dd OFFSET op_53
dd OFFSET op_54
dd OFFSET op_55
dd OFFSET op_56
dd OFFSET op_57
dd OFFSET op_58
dd OFFSET op_59
dd OFFSET op_5A
dd OFFSET op_5B
dd OFFSET op_5C
dd OFFSET op_5D
dd OFFSET op_5E
dd OFFSET op_5F
dd OFFSET op_60
dd OFFSET op_61
dd OFFSET op_62
dd OFFSET op_63
dd OFFSET op_64
dd OFFSET op_65
dd OFFSET op_66
dd OFFSET op_67
dd OFFSET op_68
dd OFFSET op_69
dd OFFSET op_6A
dd OFFSET op_6B
dd OFFSET op_6C
dd OFFSET op_6D
dd OFFSET op_6E
dd OFFSET op_6F
dd OFFSET op_70
dd OFFSET op_71
dd OFFSET op_72
dd OFFSET op_73
dd OFFSET op_74
dd OFFSET op_75
dd OFFSET op_76
dd OFFSET op_77
dd OFFSET op_78
dd OFFSET op_79
dd OFFSET op_7A
dd OFFSET op_7B
dd OFFSET op_7C
dd OFFSET op_7D
dd OFFSET op_7E
dd OFFSET op_7F
dd OFFSET op_80
dd OFFSET op_81
dd OFFSET op_82
dd OFFSET op_83
dd OFFSET op_84
dd OFFSET op_85
dd OFFSET op_86
dd OFFSET op_87
dd OFFSET op_88
dd OFFSET op_89
dd OFFSET op_8A
dd OFFSET op_8B
dd OFFSET op_8C
dd OFFSET op_8D
dd OFFSET op_8E
dd OFFSET op_8F
dd OFFSET op_90
dd OFFSET op_91
dd OFFSET op_92
dd OFFSET op_93
dd OFFSET op_94
dd OFFSET op_95
dd OFFSET op_96
dd OFFSET op_97
dd OFFSET op_98
dd OFFSET op_99
dd OFFSET op_9A
dd OFFSET op_9B
dd OFFSET op_9C
dd OFFSET op_9D
dd OFFSET op_9E
dd OFFSET op_9F
dd OFFSET op_A0
dd OFFSET op_A1
dd OFFSET op_A2
dd OFFSET op_A3
dd OFFSET op_A4
dd OFFSET op_A5
dd OFFSET op_A6
dd OFFSET op_A7
dd OFFSET op_A8
dd OFFSET op_A9
dd OFFSET op_AA
dd OFFSET op_AB
dd OFFSET op_AC
dd OFFSET op_AD
dd OFFSET op_AE
dd OFFSET op_AF
dd OFFSET op_B0
dd OFFSET op_B1
dd OFFSET op_B2
dd OFFSET op_B3
dd OFFSET op_B4
dd OFFSET op_B5
dd OFFSET op_B6
dd OFFSET op_B7
dd OFFSET op_B8
dd OFFSET op_B9
dd OFFSET op_BA
dd OFFSET op_BB
dd OFFSET op_BC
dd OFFSET op_BD
dd OFFSET op_BE
dd OFFSET op_BF
dd OFFSET op_C0
dd OFFSET op_C1
dd OFFSET op_C2
dd OFFSET op_C3
dd OFFSET op_C4
dd OFFSET op_C5
dd OFFSET op_C6
dd OFFSET op_C7
dd OFFSET op_C8
dd OFFSET op_C9
dd OFFSET op_CA
dd OFFSET op_CB
dd OFFSET op_CC
dd OFFSET op_CD
dd OFFSET op_CE
dd OFFSET op_CF
dd OFFSET op_D0
dd OFFSET op_D1
dd OFFSET op_D2
dd OFFSET op_D3
dd OFFSET op_D4
dd OFFSET op_D5
dd OFFSET op_D6
dd OFFSET op_D7
dd OFFSET op_D8
dd OFFSET op_D9
dd OFFSET op_DA
dd OFFSET op_DB
dd OFFSET op_DC
dd OFFSET op_DD
dd OFFSET op_DE
dd OFFSET op_DF
dd OFFSET op_E0
dd OFFSET op_E1
dd OFFSET op_E2
dd OFFSET op_E3
dd OFFSET op_E4
dd OFFSET op_E5
dd OFFSET op_E6
dd OFFSET op_E7
dd OFFSET op_E8
dd OFFSET op_E9
dd OFFSET op_EA
dd OFFSET op_EB
dd OFFSET op_EC
dd OFFSET op_ED
dd OFFSET op_EE
dd OFFSET op_EF
dd OFFSET op_F0
dd OFFSET op_F1
dd OFFSET op_F2
dd OFFSET op_F3
dd OFFSET op_F4
dd OFFSET op_F5
dd OFFSET op_F6
dd OFFSET op_F7
dd OFFSET op_F8
dd OFFSET op_F9
dd OFFSET op_FA
dd OFFSET op_FB
dd OFFSET op_FC
dd OFFSET op_FD
dd OFFSET op_FE
dd OFFSET op_FF

align 16
op_E0_subtable LABEL DWORD
dd OFFSET op_E0_00
dd OFFSET op_E0_10
dd OFFSET op_E0_20
dd OFFSET op_E0_30
dd OFFSET op_E0_40
dd OFFSET op_E0_50
dd OFFSET op_E0_60
dd OFFSET op_E0_70
dd OFFSET op_E0_80
dd OFFSET op_E0_90
dd OFFSET op_E0_A0
dd OFFSET op_E0_B0
dd OFFSET op_E0_C0
dd OFFSET op_E0_D0
dd OFFSET op_E0_E0
dd OFFSET op_E0_F0

align 16
op_E1_subtable LABEL DWORD
dd OFFSET op_E1_00
dd OFFSET op_E1_08
dd OFFSET op_E1_10
dd OFFSET op_E1_18
dd OFFSET op_E1_20
dd OFFSET op_E1_28
dd OFFSET op_E1_30
dd OFFSET op_E1_38
dd OFFSET op_E1_40
dd OFFSET op_E1_48
dd OFFSET op_E1_50
dd OFFSET op_E1_58
dd OFFSET op_E1_60
dd OFFSET op_E1_68
dd OFFSET op_E1_70
dd OFFSET op_E1_78
dd OFFSET op_E1_80
dd OFFSET op_E1_88
dd OFFSET op_E1_90
dd OFFSET op_E1_98
dd OFFSET op_E1_A0
dd OFFSET op_E1_A8
dd OFFSET op_E1_B0
dd OFFSET op_E1_B8
dd OFFSET op_E1_C0
dd OFFSET op_E1_C8
dd OFFSET op_E1_D0
dd OFFSET op_E1_D8
dd OFFSET op_E1_E0
dd OFFSET op_E1_E8
dd OFFSET op_E1_F0
dd OFFSET op_E1_F8

align 16
op_E4_subtable LABEL DWORD
dd OFFSET op_E4_00
dd OFFSET op_E4_40
dd OFFSET op_E4_80
dd OFFSET op_E4_C0

align 16
op_E6_subtable LABEL DWORD
dd OFFSET op_E6_00
dd OFFSET op_E6_40
dd OFFSET op_E6_80
dd OFFSET op_E6_C0

.code


cpu_init PROC commlink:DWORD	
	mov eax,commlink
	mov zombie,eax

	invoke GetStdHandle,STD_OUTPUT_HANDLE
	mov hout,eax

	pusha	
	mov edi,offset _r0
	mov ecx,8
	mov eax,0
	rep stosd
	popa
	
	ret
cpu_init ENDP



cpu_reset PROC
	pusha

	invoke zombie,ASK,MMU_READ_BYTE_CALLBACK,0,0
	mov mmu_read_byte,eax
	invoke zombie,ASK,MMU_READ_WORD_CALLBACK,0,0
	mov mmu_read_word,eax
	invoke zombie,ASK,MMU_READ_DWORD_CALLBACK,0,0
	mov mmu_read_dword,eax

	invoke zombie,ASK,MMU_WRITE_BYTE_CALLBACK,0,0
	mov mmu_write_byte,eax
	invoke zombie,ASK,MMU_WRITE_WORD_CALLBACK,0,0
	mov mmu_write_word,eax
	invoke zombie,ASK,MMU_WRITE_DWORD_CALLBACK,0,0
	mov mmu_write_dword,eax

	invoke zombie,ASK,MMU_TRANSLATE_ADDRESS_CALLBACK,0,0
	mov mmu_translate_address,eax

	mov edi,offset _r0
	mov ecx,8
	mov eax,0
	rep stosd


	mov physaddr_valid,0
	
	popa
	ret
cpu_reset ENDP


cpu_close PROC
	ret
cpu_close ENDP


cpu_config PROC hWnd:DWORD
	ret
cpu_config ENDP


cpu_set_io_handler PROC mode:DWORD,port:DWORD,pfhandler:DWORD
	push ebx

	mov eax,port
	mov ebx,pfhandler
	
	.if mode==INPUT	
		mov [inpb_handlers + eax*4],ebx
	.else
		mov [outpb_handlers + eax*4],ebx
	.endif
	
	pop ebx
	ret
cpu_set_io_handler ENDP


cpu_get PROC what:DWORD
	.if what == CPU_CYCLE_COUNT
		mov eax,cycle
	.elseif what == CPU_CYCLE_SCALING
		mov eax,1 ;200h
	.elseif what == CPU_SET_IO_CALLBACK
		mov eax,offset cpu_set_io_handler
	.elseif what == CPU_IRQ_CALLBACK
		mov eax,offset cpu_irq
	.elseif what == CPU_INPB_CALLBACK
		mov eax,offset cpu_inpb
	.elseif what == CPU_OUTPB_CALLBACK
		mov eax,offset cpu_outpb
	.elseif what == CPU_SPEED
		mov eax,speed
	.elseif what == CPU_REG_PC
		mov eax,PC
	.elseif what == CPU_REG
		mov eax,OFFSET _r0
	.elseif what == PLUGIN_NAME
		mov eax,offset cpuName
	

	.elseif what == 020h
		pusha
		invoke wsprintf,ADDR szBuffer,ADDR szFormat13,PC,_r0,_r1,_r2,_r3,_p0,_p1,_p2,_p3,_lc0,_lt0,_lb0
		invoke lstrlen,ADDR szBuffer
		invoke WriteConsole,hout,ADDR szBuffer,eax,ADDR dummy,NULL
		popa
	.endif
	ret
cpu_get ENDP


cpu_set PROC what:DWORD,param1:DWORD,param2:DWORD
	.if what == CPU_REG_PC
		mov eax,param1
		mov PC,eax
	.elseif what == CPU_REG_SP
		mov eax,param1
		mov _sp,eax
	.elseif what == CPU_CYCLE_COUNT
		mov eax,param1
		mov cycle,eax
	.elseif what == CPU_BREAKPOINT
		mov eax,param1
		mov breakpoint,eax
	.elseif what == CPU_SPEED
		mov eax,param1
		mov speed,eax
	.elseif what == CPU_IO_HANDLER
		mov eax,param1
		and param1,0FFh
		shr eax,8
		invoke cpu_set_io_handler,eax,param1,param2
	.endif
	ret
cpu_set ENDP



cpu_outpb PROC port:DWORD,dat:DWORD
	push ecx
	push dword ptr dat
	mov eax,port
	call dword ptr [outpb_handlers + eax*4]
	pop ecx
	ret
cpu_outpb ENDP


cpu_inpb PROC port:DWORD
	push ecx
	mov eax,port
	call dword ptr [inpb_handlers + eax*4]
	pop ecx
	ret
cpu_inpb ENDP


cpu_irq PROC address:DWORD
	ret
cpu_irq ENDP


cpu_execute PROC
	ret
cpu_execute ENDP


align 8

; In:  cycle threshold
; Out: executed cycles
PUBLIC cpu_execute_until
cpu_execute_until: 		
	
	pusha
	
	mov ecx,cycle			; Put cycle counter in ecx
	mov physaddr,-1			; Invalidate physical address mapping
	
	@@exe_loop:
		cmp ecx,[esp+36]	; Is the cycle count > threshold ?
		jge @@exe_done

		IF DEBUG EQ 1
		;.if PC == 080000fch
		pusha
		invoke wsprintf,ADDR szBuffer,ADDR szFormat23,PC,_r0,_r1,_r2,_r3,_p0,_p1,_p2,_p3,_p4,_p5,_lc0,_lt0,_lb0,_cc
		invoke lstrlen,ADDR szBuffer
		invoke WriteConsole,hout,ADDR szBuffer,eax,ADDR dummy,NULL
		popa
		;.endif
		ENDIF
		
		mov eax,PC
		.if eax == _lb1
			mov ebx,_lc1
			sub ebx,1
			.if ebx > 0
				mov _lc1,ebx
				mov loop1,1
				jmp @@proceed
			.else
				mov _lc1,0
			.endif
		.endif
		.if eax == _lb0
			mov ebx,_lc0
			sub ebx,1
			.if ebx > 0
				mov _lc0,ebx
				mov loop0,1
				;jmp @@exe_loop
			.else 
				mov _lc0,0
			.endif
		.endif
		@@proceed:
		
		mov eax,physaddr
		cmp eax,-1
		jne @@physaddrvalid
			;mov eax,PC
			invoke mmu_translate_address,PC
			mov physaddr,eax
		@@physaddrvalid:
		movzx ebx,word ptr [eax]

		mov eax,ebx
		shr ebx,8
		jmp dword ptr [op_table + ebx*4]

		@@next_instr::
		mov ecx,cycle

		.if loop1 != 0
			mov eax,_lt1
			mov physaddr,-1
			mov PC,eax
			mov loop1,0
			jmp @@exe_loop
		.elseif loop0 != 0
			mov eax,_lt0
			mov physaddr,-1
			mov PC,eax
			mov loop0,0
			jmp @@exe_loop
		.endif
		
		jmp @@exe_loop

	@@exe_loop_nobranch:
		cmp ecx,[esp+36]	; Is the cycle count > threshold ?
		jge @@exe_done

		IF DEBUG EQ 1
		;.if PC == 0800009ah
		pusha
		invoke wsprintf,ADDR szBuffer,ADDR szFormat23,PC,_r0,_r1,_r2,_r3,_p0,_p1,_p2,_p3,_p4,_p5,_lc0,_lt0,_lb0,_cc
		invoke lstrlen,ADDR szBuffer
		invoke WriteConsole,hout,ADDR szBuffer,eax,ADDR dummy,NULL
		popa
		;.endif
		ENDIF
		
		mov eax,PC
		.if eax == _lb1
			mov ebx,_lc1
			sub ebx,1
			.if ebx > 0
				mov _lc1,ebx
				mov loop1,1
				jmp @@proceed_nobranch
			.else
				mov _lc1,0
			.endif
		.endif
		.if eax == _lb0
			mov ebx,_lc0
			sub ebx,1
			.if ebx > 0
				mov _lc0,ebx
				mov loop0,1
				;jmp @@proceed_nobranch
			.else
				mov _lc0,0
			.endif
		.endif
		@@proceed_nobranch:
		
		mov eax,physaddr
		movzx ebx,word ptr [eax]
		mov eax,ebx
		shr ebx,8
		jmp dword ptr [op_table + ebx*4]
		@@next_instr_nobranch::
		mov ecx,cycle

		.if loop1 != 0
			mov eax,_lt1
			mov physaddr,-1
			mov PC,eax
			mov loop1,0
			jmp @@exe_loop
		.elseif loop0 != 0
			mov eax,_lt0
			mov physaddr,-1
			mov PC,eax
			mov loop0,0
			jmp @@exe_loop
		.endif

		jmp @@exe_loop_nobranch

	@@exe_done:
	popa
	

	mov eax,cycle
	ret 4



END LibMain
