// Zombie ARM7 example
// Displays a bitmap with some sprites on top
// Compile with devkitARM
//
// Mic, 2004


typedef unsigned char u8;

typedef struct
{
	u8 y,x,tile,extra;
} sprite;


#define	GPU_REG0 *(u8*)(0xFF00)
#define	GPU_REG1 *(u8*)(0xFF01)

#define STEP 13


extern int arm7_bitmap,arm7_pal,font8_bitmap,sine;
const char string[] = "Round and round..";
sprite sprites[17];



int XgsMain()
{
	int angle,i,j,*screen,*tile_bank_2,*pal;
	int *sprite_table,*sinetb;

	// Disable screen
	GPU_REG0 = 0;

	// Copy palette data
	pal = (int*)0x6012C00;
	for (i=0; i<512/4; i++)
		pal[i] = *((&arm7_pal)+i);


	// Copy image data
	screen = (int*)0x6000000;
	for (i=0; i<320*240/4; i++)
		screen[i] = *((&arm7_bitmap)+i);

	// Copy font data into 2nd tile bank (0x6020000)
	tile_bank_2 = (int*)0x6020000;
	for (i=0; i<6144; i++)
		tile_bank_2[i] = *((&font8_bitmap)+i);


	// Move all sprites off the screen (set y=0xFF)
	sprite_table = (int*)(0x6012E00);
	for (i=0; i<128; i++)
		sprite_table[i] = 0xFF;


	// Initialize sprite data
	j = 0;
	sinetb = &sine;
	for (i=0; i<17; i++)
	{
		sprites[i].y = sinetb[j&0xFF]+112;
		sprites[i].x = sinetb[(j+0x40)&0xFF]+152;
		sprites[i].tile = (string[i]<<1)-0x40;
		sprites[i].extra = 2;	// Set bit 8 of the tile# to specify bank 2
		j += STEP;
	}

	// Enable screen, set 320x240 8bpp bitmapped mode
	GPU_REG0 = 0xB4;


	angle = 0;

	// Loop forever
	while (1)
	{
		// Wait for vblank
		while ((GPU_REG1 & 0x80) == 0) { }

		// Increase angle
		angle = (angle+1)&0xFF;

		// Update sprite table
		sprite_table = (int*)(0x6012E00);
		j = angle;
		for (i=0; i<17; i++)
		{
			sprites[i].y = sinetb[j&0xFF]+112;
			sprites[i].x = sinetb[(j+0x40)&0xFF]+152;
			sprite_table[i] = *(int*)&sprites[i];
			j += STEP;
		}
	}

	return 0;
}
